/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#include "JSCanvasPixelArray.h"

#include <wtf/GetPtr.h>

#include <kjs/PropertyNameArray.h>
#include "CanvasPixelArray.h"
#include "JSCanvasPixelArrayCustom.h"

#include <kjs/JSNumberCell.h>

using namespace JSC;

namespace WebCore {

ASSERT_CLASS_FITS_IN_CELL(JSCanvasPixelArray)

/* Hash table */

static const HashTableValue JSCanvasPixelArrayTableValues[2] =
{
    { "length", DontDelete|ReadOnly, (intptr_t)jsCanvasPixelArrayLength, (intptr_t)0 },
    { 0, 0, 0, 0 }
};

static const HashTable JSCanvasPixelArrayTable = { 0, JSCanvasPixelArrayTableValues, 0 };

/* Hash table for prototype */

static const HashTableValue JSCanvasPixelArrayPrototypeTableValues[1] =
{
    { 0, 0, 0, 0 }
};

static const HashTable JSCanvasPixelArrayPrototypeTable = { 0, JSCanvasPixelArrayPrototypeTableValues, 0 };

const ClassInfo JSCanvasPixelArrayPrototype::s_info = { "CanvasPixelArrayPrototype", 0, &JSCanvasPixelArrayPrototypeTable, 0 };

JSObject* JSCanvasPixelArrayPrototype::self(ExecState* exec)
{
    return getDOMPrototype<JSCanvasPixelArray>(exec);
}

const ClassInfo JSCanvasPixelArray::s_info = { "CanvasPixelArray", 0, &JSCanvasPixelArrayTable, 0 };

JSCanvasPixelArray::JSCanvasPixelArray(PassRefPtr<StructureID> structure, PassRefPtr<CanvasPixelArray> impl)
    : DOMObject(structure)
    , m_impl(impl)
{
}

JSCanvasPixelArray::~JSCanvasPixelArray()
{
    forgetDOMObject(*Heap::heap(this)->globalData(), m_impl.get());

}

JSObject* JSCanvasPixelArray::createPrototype(ExecState* exec)
{
    return new (exec) JSCanvasPixelArrayPrototype(JSCanvasPixelArrayPrototype::createStructureID(exec->lexicalGlobalObject()->objectPrototype()));
}

bool JSCanvasPixelArray::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    bool ok;
    unsigned index = propertyName.toUInt32(&ok, false);
    if (ok && index < static_cast<CanvasPixelArray*>(impl())->length()) {
        slot.setValue(getByIndex(exec, index));
        return true;
    }
    return getStaticValueSlot<JSCanvasPixelArray, Base>(exec, &JSCanvasPixelArrayTable, this, propertyName, slot);
}

bool JSCanvasPixelArray::getOwnPropertySlot(ExecState* exec, unsigned propertyName, PropertySlot& slot)
{
    if (propertyName < static_cast<CanvasPixelArray*>(impl())->length()) {
        slot.setValue(getByIndex(exec, propertyName));
        return true;
    }
    return getOwnPropertySlot(exec, Identifier::from(exec, propertyName), slot);
}

JSValuePtr jsCanvasPixelArrayLength(ExecState* exec, const Identifier&, const PropertySlot& slot)
{
    CanvasPixelArray* imp = static_cast<CanvasPixelArray*>(static_cast<JSCanvasPixelArray*>(asObject(slot.slotBase()))->impl());
    return jsNumber(exec, imp->length());
}

void JSCanvasPixelArray::put(ExecState* exec, const Identifier& propertyName, JSValuePtr value, PutPropertySlot& slot)
{
    bool ok;
    unsigned index = propertyName.toUInt32(&ok, false);
    if (ok) {
        indexSetter(exec, index, value);
        return;
    }
    Base::put(exec, propertyName, value, slot);
}

void JSCanvasPixelArray::put(ExecState* exec, unsigned propertyName, JSValuePtr value)
{
    indexSetter(exec, propertyName, value);
    return;
}

void JSCanvasPixelArray::getPropertyNames(ExecState* exec, PropertyNameArray& propertyNames)
{
    for (unsigned i = 0; i < static_cast<CanvasPixelArray*>(impl())->length(); ++i)
        propertyNames.add(Identifier::from(exec, i));
     Base::getPropertyNames(exec, propertyNames);
}

JSC::JSValuePtr toJS(JSC::ExecState* exec, CanvasPixelArray* object)
{
    return getDOMObjectWrapper<JSCanvasPixelArray>(exec, object);
}
CanvasPixelArray* toCanvasPixelArray(JSC::JSValuePtr value)
{
    return value->isObject(&JSCanvasPixelArray::s_info) ? static_cast<JSCanvasPixelArray*>(asObject(value))->impl() : 0;
}

}
